using Syncfusion.Blazor.HeatMap;
using System;
using System.Threading.Tasks;

namespace BlazorApp1.Pages
{
    public partial class Index
    {
        private SfHeatMap<object> Heatmap { get; set; }
        public int[,] HeatmapDatasource { get; set; } = new int[10, 10];
        public string XLabel = "0";
        public string YLabel = "0";
        public string XValue = "0";
        public string YValue = "0";
        public string X ="0";
        public string Y = "0";

        private double[,] GetDefaultData()
        {
            double[,] dataSource = new double[2, 10]
                {
                {9, 2, 4, 8, 5, 3, 4, 4, 2, 4 },
                {5, 1, 6, 4, 9, 3, 5, 8, 6, 2}
                };
            return dataSource;
        }

        public object HeatMapData { get; set; }
        private int cellStepSec = 10;
        private object cellsStep;
        private void ChangeDataSource()

        {

            HeatMapData = GetDefaultData2();

            InvokeAsync(StateHasChanged);

        }

        private int[,] GetDefaultData2()
        {
            int[,] dataSource = new int[,]
            {
                {52, 65, 67, 45, 37, 52},
                {68, 52, 63, 51, 30, 51},
                {7, 16, 47, 47, 88, 6},
                {66, 64, 46, 40, 47, 41},
                {14, 46, 97, 69, 69, 3},
                {54, 46, 61, 46, 40, 39}
            };
            return dataSource;
        }


        protected override void OnInitialized()
        {
            HeatMapData = GetDefaultData();
            cellsStep = 3600 / cellStepSec;
            HeatmapDatasource = FillDataSourceColumns();
            HeatMapData = ChangeDataSourceColumns();
        }
        private int[,] FillDataSourceColumns()
        {
            int[,] array = new int[Convert.ToInt32(cellsStep), 8];
            Random rnd = new Random();

            for (int i = 0; i < Convert.ToInt32(cellsStep); i++)
            {
                for (int j = 0; j < 8; j++)
                {
                    array[i, j] = rnd.Next(1, 3);
                }
            }
            return array;
        }

        private int[,] ChangeDataSourceColumns()
        {
            int[,] array = new int[Convert.ToInt32(cellsStep), 8];

            for (int i = 0; i < Convert.ToInt32(cellsStep); i++)
            {
                for (int j = 0; j < 8; j++)
                {
                    array[i, j] = HeatmapDatasource[i, j];
                }
            }
            return array;
        }

        public void HeatmapOnLoad(LoadedEventArgs args)
        {
        }

        private async void Resized(ResizeEventArgs args)
        {
            try
            {
                await Heatmap.RefreshBoundAsync();
            }
            catch (Exception ex)
            {
            }
        }

        private void Created(object args)
        {
        }

        private void CellRender(HeatMapCellRenderEventArgs args)
        {
            switch (args.CellValue)
            {
                case "0":
                    {
                        args.CellColor = "#ECECEC";
                        break;
                    }
                case "1":
                    {
                        args.CellColor = "#9ACC68";
                        break;
                    }
                case "2":
                    {
                        args.CellColor = "#007214";
                        break;
                    }
                case "3":
                    {
                        args.CellColor = "#ECE900";
                        break;
                    }
                case "4":
                    {
                        args.CellColor = "#FFAF55";
                        break;
                    }
                case "5":
                    {
                        args.CellColor = "#FF8080";
                        break;
                    }
                case "6":
                    {
                        args.CellColor = "#ff2323";
                        break;
                    }
                case "7":
                    {
                        args.CellColor = "#CACD02";
                        break;
                    }
                case "8":
                    {
                        args.CellColor = "#AF1313";
                        break;
                    }
                case "10":
                    {
                        args.CellColor = "#5062D1";
                        break;
                    }
                default:
                    args.CellColor = "#5062D1";
                    break;
            }
        }

        public async Task CellIsClickedAsync(CellClickEventArgs args)
        {
            XLabel = args.XLabel;
            YLabel = args.YLabel;
            XValue = args.XValue;
            YValue = args.YValue;
            X = args.X;
            Y = args.Y;
        }
    }
}